diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 8d2144ccd..ec2dbef7a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -13,7 +13,9 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.overworld.BiomeOutback;
@@ -27,14 +29,14 @@ import java.util.Random;
 public class ChunkDecoratorOverworld
     implements ChunkDecorator {
     private final @NotNull World world;
-    private final @NotNull PerlinNoise treeDensityNoise;
+    private final @NotNull FractalNoise2D<ImprovedPerlinNoise> treeDensityNoise;
     private final int treeDensityOverride;
 
     protected ChunkDecoratorOverworld(@NotNull World world, int treeDensityOverride) {
         this.world = world;
         this.treeDensityOverride = treeDensityOverride;
 
-        this.treeDensityNoise = new PerlinNoise(world.getRandomSeed(), 8, 74);
+        this.treeDensityNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 74));
     }
 
     public ChunkDecoratorOverworld(@NotNull World world) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
index 74e17969a..857db278a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/DensityGeneratorOverworld.java
@@ -1,33 +1,33 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.noise.*;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
-import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class DensityGeneratorOverworld
     implements DensityGenerator {
     private final @NotNull World world;
 
-    private final @NotNull PerlinNoise minLimitNoise;
-    private final @NotNull PerlinNoise maxLimitNoise;
-    private final @NotNull PerlinNoise mainNoise;
-    private final @NotNull PerlinNoise scaleNoise;
-    private final @NotNull PerlinNoise depthNoise;
+    private final @NotNull Noise3D minLimitNoise;
+    private final @NotNull Noise3D maxLimitNoise;
+    private final @NotNull Noise3D mainNoise;
+    private final @NotNull Noise2D scaleNoise;
+    private final @NotNull Noise2D depthNoise;
 
     private final boolean generateRivers;
-    private final @NotNull PerlinNoise smoothingRiverNoise;
-    private final @NotNull PerlinNoise carvingRiverNoise;
+    private final @NotNull Noise2D smoothingRiverNoise;
+    private final @NotNull Noise2D carvingRiverNoise;
 
     protected DensityGeneratorOverworld(
         @NotNull World world,
-        @NotNull PerlinNoise minLimitNoise,
-        @NotNull PerlinNoise maxLimitNoise,
-        @NotNull PerlinNoise mainNoise,
-        @NotNull PerlinNoise scaleNoise,
-        @NotNull PerlinNoise depthNoise,
+        @NotNull Noise3D minLimitNoise,
+        @NotNull Noise3D maxLimitNoise,
+        @NotNull Noise3D mainNoise,
+        @NotNull Noise2D scaleNoise,
+        @NotNull Noise2D depthNoise,
         boolean generateRivers
     ) {
         this.world = world;
@@ -39,17 +39,17 @@ public class DensityGeneratorOverworld
         this.depthNoise = depthNoise;
 
         this.generateRivers = generateRivers;
-        this.smoothingRiverNoise = new PerlinNoise(world.getRandomSeed(), 1);
-        this.carvingRiverNoise = new PerlinNoise(world.getRandomSeed() + 1, 1);
+        this.smoothingRiverNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 1));
+        this.carvingRiverNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed() + 1, 1));
     }
 
     public DensityGeneratorOverworld(@NotNull World world) {
         this(world,
-            new PerlinNoise(world.getRandomSeed(), 16, 0),
-            new PerlinNoise(world.getRandomSeed(), 16, 16),
-            new PerlinNoise(world.getRandomSeed(), 8, 32),
-            new PerlinNoise(world.getRandomSeed(), 10, 48),
-            new PerlinNoise(world.getRandomSeed(), 16, 58),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 0)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 16)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 32)),
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 10, 48)),
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 58)),
             true
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
index 45c116ed5..f9c10f834 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
@@ -9,7 +9,7 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.*;
 import org.jetbrains.annotations.NotNull;
 
 public class SurfaceGeneratorOverworld
@@ -17,14 +17,19 @@ public class SurfaceGeneratorOverworld
 {
     private final World world;
 
-    private final PerlinNoise beachNoise;
-    private final PerlinNoise soilNoise;
-    private final PerlinNoise mainNoise;
+    private final Noise3D beachNoise;
+    private final Noise3D soilNoise;
+    private final Noise3D mainNoise;
 
     private final boolean generateStoneVariants;
 
-    protected SurfaceGeneratorOverworld(World world, PerlinNoise beachNoise, PerlinNoise soilNoise, PerlinNoise mainNoise, boolean generateStoneVariants)
-    {
+    protected SurfaceGeneratorOverworld(
+        World world,
+        Noise3D beachNoise,
+        Noise3D soilNoise,
+        Noise3D mainNoise,
+        boolean generateStoneVariants
+    ) {
         this.world = world;
         this.beachNoise = beachNoise;
         this.soilNoise = soilNoise;
@@ -35,9 +40,9 @@ public class SurfaceGeneratorOverworld
     public SurfaceGeneratorOverworld(World world)
     {
         this(world,
-             new PerlinNoise(world.getRandomSeed(), 4, 40),
-             new PerlinNoise(world.getRandomSeed(), 4, 44),
-             new PerlinNoise(world.getRandomSeed(), 8, 32),
+             new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4, 40)),
+             new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4, 44)),
+             new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 32)),
              true
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
index 973d8438e..9c3ce9602 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
@@ -8,8 +8,9 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
-import net.minecraft.core.world.noise.LegacyNoiseType;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -17,12 +18,12 @@ import java.util.Random;
 public class ChunkDecoratorOverworldB173
     implements ChunkDecorator {
     private final @NotNull World world;
-    private final @NotNull PerlinNoise forestNoise;
+    private final @NotNull FractalNoise2D<ImprovedPerlinNoise> forestNoise;
 
     public ChunkDecoratorOverworldB173(final @NotNull World world) {
         this.world = world;
 
-        this.forestNoise = new PerlinNoise(world.getRandomSeed(), 8, 82, LegacyNoiseType.BETA);
+        this.forestNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 82, ImprovedPerlinNoise.LegacyNoiseType.BETA));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
index 49b398e2b..7c009e847 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
@@ -2,8 +2,9 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld.b173;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.DensityGeneratorOverworld;
-import net.minecraft.core.world.noise.LegacyNoiseType;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class DensityGeneratorOverworldB173
@@ -11,11 +12,11 @@ public class DensityGeneratorOverworldB173
 
     public DensityGeneratorOverworldB173(final @NotNull World world) {
         super(world,
-            new PerlinNoise(world.getRandomSeed(), 16, 0, LegacyNoiseType.BETA),
-            new PerlinNoise(world.getRandomSeed(), 16, 16, LegacyNoiseType.BETA),
-            new PerlinNoise(world.getRandomSeed(), 8, 32, LegacyNoiseType.BETA),
-            new PerlinNoise(world.getRandomSeed(), 10, 48, LegacyNoiseType.BETA),
-            new PerlinNoise(world.getRandomSeed(), 16, 58, LegacyNoiseType.BETA),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 0)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 16)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 32)),
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 10, 48)),
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 58)),
             false
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java
index add4478aa..975fe9c46 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/SurfaceGeneratorOverworldB173.java
@@ -2,17 +2,18 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld.b173;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
-import net.minecraft.core.world.noise.LegacyNoiseType;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class SurfaceGeneratorOverworldB173
     extends SurfaceGeneratorOverworld {
     public SurfaceGeneratorOverworldB173(final @NotNull World world) {
         super(world,
-            new PerlinNoise(world.getRandomSeed(), 4, 40, LegacyNoiseType.BETA),
-            new PerlinNoise(world.getRandomSeed(), 4, 44, LegacyNoiseType.BETA),
-            new PerlinNoise(world.getRandomSeed(), 8, 32, LegacyNoiseType.BETA),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4, 40, ImprovedPerlinNoise.LegacyNoiseType.BETA)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4, 44, ImprovedPerlinNoise.LegacyNoiseType.BETA)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 32, ImprovedPerlinNoise.LegacyNoiseType.BETA)),
             false
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
index 493abff0f..f1723b767 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
@@ -13,16 +13,18 @@ import net.minecraft.core.world.generate.chunk.ChunkFeatureDecorator;
 import net.minecraft.core.world.generate.feature.*;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class ChunkDecoratorOverworldHell
     extends ChunkFeatureDecorator {
-    private final @NotNull PerlinNoise treeDensityNoise;
+    private final @NotNull FractalNoise2D<ImprovedPerlinNoise> treeDensityNoise;
 
     public ChunkDecoratorOverworldHell(final @NotNull World world) {
         super(world);
-        this.treeDensityNoise = new PerlinNoise(world.getRandomSeed(), 8, 74);
+        this.treeDensityNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 74));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
index fa68e82fa..dcc1771f2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/ChunkDecoratorOverworldRetro.java
@@ -14,8 +14,9 @@ import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
-import net.minecraft.core.world.noise.LegacyNoiseType;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -23,14 +24,14 @@ import java.util.Random;
 public class ChunkDecoratorOverworldRetro
     implements ChunkDecorator {
     private final @NotNull World world;
-    private final @NotNull PerlinNoise treeDensityNoise;
+    private final @NotNull FractalNoise2D<ImprovedPerlinNoise> treeDensityNoise;
 
     private final boolean snowCovered;
 
     public ChunkDecoratorOverworldRetro(@NotNull World world) {
         this.world = world;
 
-        this.treeDensityNoise = new PerlinNoise(world.getRandomSeed(), 8, 74, LegacyNoiseType.ALPHA);
+        this.treeDensityNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 74, ImprovedPerlinNoise.LegacyNoiseType.ALPHA));
 
         this.snowCovered = false;//new Random(world.getRandomSeed()).nextBoolean();
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java
index e7f96ccc2..64a4d79cd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java
@@ -2,19 +2,20 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld.retro;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.DensityGeneratorOverworld;
-import net.minecraft.core.world.noise.LegacyNoiseType;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class DensityGeneratorOverworldRetro
     extends DensityGeneratorOverworld {
     public DensityGeneratorOverworldRetro(@NotNull World world) {
         super(world,
-            new PerlinNoise(world.getRandomSeed(), 16, 0, LegacyNoiseType.ALPHA),
-            new PerlinNoise(world.getRandomSeed(), 16, 16, LegacyNoiseType.ALPHA),
-            new PerlinNoise(world.getRandomSeed(), 8, 32, LegacyNoiseType.ALPHA),
-            new PerlinNoise(world.getRandomSeed(), 10, 48, LegacyNoiseType.ALPHA),
-            new PerlinNoise(world.getRandomSeed(), 16, 58, LegacyNoiseType.ALPHA),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 0)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 16)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 32)),
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 10, 48)),
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 58)),
             false
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/SurfaceGeneratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/SurfaceGeneratorOverworldRetro.java
index ec1e983d9..0f7d2cd3a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/SurfaceGeneratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/SurfaceGeneratorOverworldRetro.java
@@ -2,17 +2,17 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld.retro;
 
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.SurfaceGeneratorOverworld;
-import net.minecraft.core.world.noise.LegacyNoiseType;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class SurfaceGeneratorOverworldRetro
     extends SurfaceGeneratorOverworld {
     public SurfaceGeneratorOverworldRetro(@NotNull World world) {
         super(world,
-            new PerlinNoise(world.getRandomSeed(), 4, 40, LegacyNoiseType.ALPHA),
-            new PerlinNoise(world.getRandomSeed(), 4, 44, LegacyNoiseType.ALPHA),
-            new PerlinNoise(world.getRandomSeed(), 8, 32, LegacyNoiseType.ALPHA),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4, 40, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4, 44, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 32, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
             false
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
index 46f213224..aa5b02e60 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMudPatch.java
@@ -2,13 +2,13 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 
 import java.util.Random;
 
 public class WorldFeatureMudPatch extends WorldFeature
 {
-    private static final ImprovedNoise noise = new ImprovedNoise(new Random(0));
+    private static final ImprovedPerlinNoise noise = new ImprovedPerlinNoise(new Random(0));
 
     @Override
 	public boolean place(World world, Random random, int x, int y, int z) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise2D.java
new file mode 100644
index 000000000..9e86a5bb6
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise2D.java
@@ -0,0 +1,66 @@
+package net.minecraft.core.world.noise;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class FractalNoise2D<T extends Noise2D>
+    implements Noise2D {
+    public static final double DEFAULT_LACUNARITY = 0.5;
+    public static final double DEFAULT_PERSISTENCE = 2.0;
+
+    protected final @NotNull T @NotNull [] octaves;
+
+    protected double lacunarity = DEFAULT_LACUNARITY;
+    protected double persistence = DEFAULT_PERSISTENCE;
+
+    public FractalNoise2D(final @NotNull T @NotNull [] octaves) {
+        this.octaves = octaves;
+    }
+
+    public final @NotNull FractalNoise2D<T> setLacunarity(final double lacunarity) {
+        this.lacunarity = lacunarity;
+        return this;
+    }
+
+    public final @NotNull FractalNoise2D<T> setPersistence(final double persistence) {
+        this.persistence = persistence;
+        return this;
+    }
+
+    @Override
+    public double getValue(final double x, final double z) {
+        double out = 0.0;
+        double frequency = 1.0;
+        double amplitude = 1.0;
+
+        for (final @NotNull T octave : this.octaves) {
+            out += octave.getValue(x * frequency, z * frequency) * amplitude;
+            frequency *= this.lacunarity;
+            amplitude *= this.persistence;
+        }
+
+        return out;
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        double amplitude
+    ) {
+        if (out == null || out.length < xSize * zSize) {
+            out = new double[xSize * zSize];
+        }
+
+        double frequency = 1.0;
+        for (final @NotNull T octave : this.octaves) {
+            octave.addRegion(out, x, z, xSize, zSize, xScale * frequency, zScale * frequency, amplitude);
+            frequency *= this.lacunarity;
+            amplitude *= this.persistence;
+        }
+
+        return out;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise3D.java
new file mode 100644
index 000000000..65c2c7d0a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/FractalNoise3D.java
@@ -0,0 +1,50 @@
+package net.minecraft.core.world.noise;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class FractalNoise3D<T extends Noise3D>
+    extends FractalNoise2D<T>
+    implements Noise3D {
+
+    public FractalNoise3D(final @NotNull T @NotNull [] octaves) {
+        super(octaves);
+    }
+
+    @Override
+    public double getValue(final double x, final double y, final double z) {
+        double out = 0.0;
+        double frequency = 1.0;
+        double amplitude = 1.0;
+
+        for (final @NotNull T octave : this.octaves) {
+            out += octave.getValue(x * frequency, y * frequency, z * frequency) * amplitude;
+            frequency *= this.lacunarity;
+            amplitude *= this.persistence;
+        }
+
+        return out;
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale,
+        double amplitude
+    ) {
+        if (out == null || out.length < xSize * ySize * zSize) {
+            out = new double[xSize * ySize * zSize];
+        }
+
+        double frequency = 1.0;
+        for (final @NotNull T octave : this.octaves) {
+            octave.addRegion(out, x, y, z, xSize, ySize, zSize, xScale * frequency, yScale * frequency, zScale * frequency, amplitude);
+            frequency *= this.lacunarity;
+            amplitude *= this.persistence;
+        }
+
+        return out;
+    }
+}
